<template>
    <span>{{text}}</span>
</template>

<script lang="ts">
import { Vue, Component, Prop,Watch,Model } from 'vue-property-decorator';
import CodeListService from "@service/app/codelist-service";

@Component({})
export default class DropDownList extends Vue {
    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof AppSpan
     */  
    public codeListService:CodeListService = new CodeListService({ $store: this.$store });

    /**
     * 当前值
     * 
     * @type {*}
     * @memberof AppSpan
     */
    @Prop() public data?: any;


    /**
     * 监控表单属性 data 值
     *
     * @memberof AppSpan
     */
    @Watch('data')
    onDataChange(newVal: any, oldVal: any) {
        if(newVal !== oldVal){
           this.load();
        }
    }

    /**
     * 显示值
     * @type {*}
     * @memberof AppSpan
     */
    public text:any = '';

    /**
     * 代码表标识
     *
     * @type {string}
     * @memberof AppSpan
     */
    @Prop() public tag?: string;

    /**
     * 代码表类型
     *
     * @type {string}
     * @memberof AppSpan
     */
    @Prop() public codelistType?: string;

    /**
     * 代码表
     *
     * @type {any[]}
     * @memberof AppSpan
     */
    public items: any[] = [];

    /**
     * vue  生命周期
     *
     * @memberof AppSpan
     */
    public created() {
        this.load();
    }

    /**
     * 加载代码表
     * 
     * @memberof AppSpan
     */
    public load(){
        if(this.tag && Object.is(this.codelistType,"STATIC")){
            const codelist = this.$store.getters.getCodeList(this.tag);
            if (codelist) {
                this.items = [...JSON.parse(JSON.stringify(codelist.items))];
                this.setText();
            } else {
                console.log(`----${this.tag}----代码表不存在`);
            }
        }else if(this.tag && Object.is(this.codelistType,"DYNAMIC")){
            this.codeListService.getItems(this.tag).then((res:any) => {
                this.items = res;
                this.setText();
            }).catch((error:any) => {
                console.log(`----${this.tag}----代码表不存在`);
            });
        }else{
            this.setText();
        }
    }

    /**
     * 设置显示值
     * @memberof AppSpan
     */
    public setText(){
      if(this.items.length>0){
          let currentItem:any = this.items.find((item:any)=>{
              return item.value == this.data;
          });
          if(currentItem){
              this.text = currentItem.label;
          }
      }else{
          this.text = this.data;
      }
    }
    
}
</script>

<style lang='less'>
@import './app-span.less';
</style>